package lib.dw;

public class DwTagEncodings
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private DwTagEncodings (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  public boolean equals (Object o)
  {
    if (o instanceof DwTagEncodings)
      return ((DwTagEncodings) o).enumValue == this.enumValue;
    else
      return false;
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    DwTagEncodings rhs = (DwTagEncodings) o; // Can throw - ok.
    return rhs.enumValue - this.enumValue;
  }
  static public final int DW_TAG_array_type_ = 0x01;
  static public final DwTagEncodings DW_TAG_array_type = new DwTagEncodings (0x01, "DwTagEncodings_DW_TAG_array_type", "DW TAG array type", "DW_TAG_array_type");
  static public final int DW_TAG_formal_parameter_ = 0x05;
  static public final DwTagEncodings DW_TAG_formal_parameter = new DwTagEncodings (0x05, "DwTagEncodings_DW_TAG_formal_parameter", "DW TAG formal parameter", "DW_TAG_formal_parameter");
  static public final int DW_TAG_structure_type_ = 0x13;
  static public final DwTagEncodings DW_TAG_structure_type = new DwTagEncodings (0x13, "DwTagEncodings_DW_TAG_structure_type", "DW TAG structure type", "DW_TAG_structure_type");
  static public final int DW_TAG_typedef_ = 0x16;
  static public final DwTagEncodings DW_TAG_typedef = new DwTagEncodings (0x16, "DwTagEncodings_DW_TAG_typedef", "DW TAG typedef", "DW_TAG_typedef");
  static public final int DW_TAG_inlined_subroutine_ = 0x1d;
  static public final DwTagEncodings DW_TAG_inlined_subroutine = new DwTagEncodings (0x1d, "DwTagEncodings_DW_TAG_inlined_subroutine", "DW TAG inlined subroutine", "DW_TAG_inlined_subroutine");
  static public final int DW_TAG_base_type_ = 0x24;
  static public final DwTagEncodings DW_TAG_base_type = new DwTagEncodings (0x24, "DwTagEncodings_DW_TAG_base_type", "DW TAG base type", "DW_TAG_base_type");
  static public final int DW_TAG_subprogram_ = 0x2e;
  static public final DwTagEncodings DW_TAG_subprogram = new DwTagEncodings (0x2e, "DwTagEncodings_DW_TAG_subprogram", "DW TAG subprogram", "DW_TAG_subprogram");
  static public final int DW_TAG_variable_ = 0x34;
  static public final DwTagEncodings DW_TAG_variable = new DwTagEncodings (0x34, "DwTagEncodings_DW_TAG_variable", "DW TAG variable", "DW_TAG_variable");

  /** Create a HashMap containing all the DwTagEncodings elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (DW_TAG_array_type.enumString, DW_TAG_array_type);
    map.put (DW_TAG_formal_parameter.enumString, DW_TAG_formal_parameter);
    map.put (DW_TAG_structure_type.enumString, DW_TAG_structure_type);
    map.put (DW_TAG_typedef.enumString, DW_TAG_typedef);
    map.put (DW_TAG_inlined_subroutine.enumString, DW_TAG_inlined_subroutine);
    map.put (DW_TAG_base_type.enumString, DW_TAG_base_type);
    map.put (DW_TAG_subprogram.enumString, DW_TAG_subprogram);
    map.put (DW_TAG_variable.enumString, DW_TAG_variable);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the DwTagEncodings object that matches the string.  */
  public static DwTagEncodings valueOf (String string)
  {
    return (DwTagEncodings)enumMap.get (string);
  }

  /** Return the DwTagEncodings object that matches the integer.  */
  public static DwTagEncodings valueOf (long i)
  {
    switch ((int)i) {
    case DW_TAG_array_type_: return DW_TAG_array_type;
    case DW_TAG_formal_parameter_: return DW_TAG_formal_parameter;
    case DW_TAG_structure_type_: return DW_TAG_structure_type;
    case DW_TAG_typedef_: return DW_TAG_typedef;
    case DW_TAG_inlined_subroutine_: return DW_TAG_inlined_subroutine;
    case DW_TAG_base_type_: return DW_TAG_base_type;
    case DW_TAG_subprogram_: return DW_TAG_subprogram;
    case DW_TAG_variable_: return DW_TAG_variable;
    default: return null;
    }
  }

  /** Return an array of all the DwTagEncodings elements.  */
  public static DwTagEncodings[] values ()
  {
    return (DwTagEncodings[]) enumMap.values ().toArray (new DwTagEncodings[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    DwTagEncodings c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    DwTagEncodings c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    DwTagEncodings c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    DwTagEncodings c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    DwTagEncodings c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }
}
